﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.IO;

namespace maps
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        public Point mdown = Point.Empty;

        private void Form1_Load(object sender, EventArgs e)
        {
            pictureBox1.Image = Bitmap.FromFile("texture.jpg");
            int quality = (int)numericUpDown1.Value; //podrobnost
            int zoom = (int)numericUpDown2.Value; //přiblížení
            int size = 0;
            switch (quality)
            {
                case 0:
                    size = 3;
                    break;
                case 1:
                    size = 6;
                    break;
                case 2:
                    size = 12;
                    break;
                case 3:
                    size = 24;
                    break;
                case 4:
                    size = 48;
                    break;
                case 5:
                    size = 96;
                    break;
                case 6:
                    size = 192;
                    break;
                case 7:
                    size = 384;
                    break;
                case 8:
                    size = 768;
                    break;
                case 9:
                    size = 1536;
                    break;
            }
            //size = size / zoom;
            for (int a = 0; a < size; a++)
            {
                for (int b = 0; b < size; b++)
                {
                    int posx = 0; int posy = 0;
                    try { posx = 1280/size*a; }
                    catch{}
                    try { posy = 960/size*b; }
                    catch{}
                    DrawPeace(a, b, (int)numericUpDown1.Value, posx, posy, size);
                }
            }
            pictureBox1.Width = (int)(2304 * zoom);
            pictureBox1.Height = (int)(2304 * zoom);
            pictureBox1.SizeMode = PictureBoxSizeMode.StretchImage;
            pictureBox1.Top = (int)numericUpDown3.Value;
            pictureBox1.Left = (int)numericUpDown4.Value;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            Form1_Load(sender, e);
        }
        void DrawPeace(int x, int y, int z, int coordx, int coordy, int size)
        {
            string webpath = z.ToString() + "/" + x.ToString() + "/" + y.ToString() + ".jpg";
            string path = z.ToString() + "x" + x.ToString() + "x" + y.ToString() + ".jpg";
            string server = textBox1.Text + "/";
            WebClient wc = new WebClient();
            try
            {
                if (File.Exists(path) == false) wc.DownloadFile(server + webpath, path);
                //MessageBox.Show(x.ToString() + ", " + y.ToString() + ", " + z.ToString());
                Image peace = Image.FromFile(path);
                Image pre = pictureBox1.Image;
                Graphics g = Graphics.FromImage(pre);
                g.DrawImage(peace, coordx, coordy, 1280 / size, 960 / size);
                pictureBox1.Image = pre;
                pictureBox1.Refresh();
            }
            catch { }
            
        }
        private void pictureBox1_MouseMove(object sender, MouseEventArgs e)
        {

            if (e.Button == MouseButtons.Left)
            {
                Point mpos = e.Location;
                int dX = mpos.X - mdown.X;
                int dY = mpos.Y - mdown.Y;
                int newx = pictureBox1.Location.X + dX;
                int newy = pictureBox1.Location.Y + dY;
                pictureBox1.Location = new Point(newx, newy);
            }
        }

        private void pictureBox1_MouseDown(object sender, MouseEventArgs e)
        {
            mdown = e.Location;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            //pictureBox1.Width = 2304;
            //pictureBox1.Height = 2304;
            //pictureBox1.SizeMode = PictureBoxSizeMode.StretchImage;
            pictureBox1.Top = 0;
            pictureBox1.Left = 0;
        }
    }
}
